import shlex
import subprocess
import time

import discord


class FFmpegNormalAudio(discord.FFmpegAudio):
    def __init__(
            self, source, *, executable='ffmpeg', pipe=False, stderr=None, before_options=None, options=None,
            tor: bool
    ):
        args = []
        if tor:
            args.append(executable)
            executable = 'torify'

        subprocess_kwargs = {'stdin': source if pipe else subprocess.DEVNULL, 'stderr': stderr}

        if isinstance(before_options, str):
            args.extend(shlex.split(before_options))

        args.append('-i')
        args.append('-' if pipe else source)
        args.extend(('-f', 's16le', '-ar', '48000', '-ac', '2', '-loglevel', 'warning'))

        if isinstance(options, str):
            args.extend(shlex.split(options))

        args.append('pipe:1')

        super().__init__(source, executable=executable, args=args, **subprocess_kwargs)

    def read(self):
        ret = self._stdout.read(discord.opus.Encoder.FRAME_SIZE)
        if len(ret) != discord.opus.Encoder.FRAME_SIZE:
            if self._process.poll() is None:
                time.sleep(.5)
            return b''
        return ret

    def is_opus(self):
        return False
